module(..., package.seeall)

--====================================================================--        
-- CAR CLASS
--====================================================================--

-- General functions ( working as a module/package/library )
function set ( p )
	print("car.set: " .. p )
end
function get ()
	return "ok"
end

-- Class body
function new ( params )

	-- New Object
	local tabCar = display.newGroup()
	
	-- Attributes
	tabCar.name = "default"
	
	-- Constructor
	if type( params ) ~= "nil" then
	
		-- Name
		if params.name then
			tabCar.name = tostring( params.name )
		end
		
		-- Image
		if type(params.image) == "string" then
			if  type( params.width  ) == "number"
			and type( params.height ) == "number"
			then
				tabCar.body = display.newImageRect( params.image, params.width, params.height )
			else
				tabCar.body = display.newImage( params.image )
			end
			tabCar:insert( tabCar.body )
		else
			print ( "Car ERROR: You have to inform an image" )
			error ()
		end
		
	end
	
	-- Methods
	function tabCar.setName ( pName )
		if type( pName ) == "string" then
			tabCar.name = pName
		end
	end
	--
	function tabCar.getName ()
		return tabCar.name
	end
	
	-- Return
	return tabCar
	
end